public class Datenknoten extends Datenelement{
    private Inhalt meinInhalt;
    private Datenelement next;
    
    public Datenknoten(Inhalt newInhalt) {
        meinInhalt = newInhalt;
        next = new Abschluss();
    }
    
    public Datenknoten hinzufuegen(Inhalt newInhalt) {
        next = next.hinzufuegen(newInhalt);
        return this;
    }
    
    public Datenelement getNext() {
        return next;
    }
    
    public int gibAnzahl() {
        return next.gibAnzahl()+1;
    }
    
    public void p() {
        meinInhalt.p();
        next.p();
    }
    
    public String[] getInhaltInfos() {
        return meinInhalt.getInfos();
    }
    
    public String getAllInfos() {
        return meinInhalt.getAllInfos()+ "#"+ next.getAllInfos();
    }
    
    public String getAllInfosForGUI() {
        String[] curInhalt = meinInhalt.getInfos();
        //String resultForGUI = ""+(Integer.parseInt(curInhalt[1].substring(6, 8)))+"."+(Integer.parseInt(curInhalt[1].substring(4, 6)))+".;"; //datum ohne Nullen
        String resultForGUI = curInhalt[1].substring(6, 8)+"."+curInhalt[1].substring(4, 6)+".;"; //datum MIT Nullen
        resultForGUI +=  curInhalt[0]+";"; //fach
        resultForGUI +=  curInhalt[2]+";"; //inhalt
        resultForGUI +=  curInhalt[3]+";"; //priority
        String isDone =  "nicht erledigt"; //erledigt
        if (curInhalt[4].equals("true")) {
            isDone =  "erledigt";
        }
        resultForGUI += isDone;
        return resultForGUI+"#"+next.getAllInfosForGUI();
    }
    
    public int count() {
        return 1+next.count();
    }
}
