 

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import java.util.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 02.12.2016
  * @author 
  */

public class GUI_HAEingabe extends JFrame {
    private HA_Liste myHA_list;
    
  // Anfang Attribute
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JLabel jLabel3 = new JLabel();
  private JLabel jLabel4 = new JLabel();
  private JSpinner jSpinner1_day = new JSpinner();
    private SpinnerNumberModel jSpinner1_day_dayModel = new SpinnerNumberModel(1, 1, 31, 1);
  private JLabel jLabel5 = new JLabel();
  private JLabel jLabel6 = new JLabel();
  private JSpinner jSpinner1_month = new JSpinner();
    private SpinnerNumberModel jSpinner1_monthModel = new SpinnerNumberModel(12, 1, 12, 1);
  private JLabel jLabel7 = new JLabel();
  private JSpinner jSpinner1_year = new JSpinner();
    private SpinnerNumberModel jSpinner1_yearModel = new SpinnerNumberModel(2016, 2010, 2100, 1);
  private JLabel jLabel8 = new JLabel();
  private JComboBox<String> jComboBox1_prioritaet = new JComboBox<String>();
  private JComboBox<String> jComboBox1_choosedDate = new JComboBox<String>();
  private JComboBox<String> jComboBox1_fach = new JComboBox<String>();
  private JLabel jLabel9 = new JLabel();
  private JTextArea jTextArea1_inhalt = new JTextArea("");
    private JScrollPane jTextArea1_inhalt_inhaltScrollPane = new JScrollPane(jTextArea1_inhalt);
  private JButton jButton1_speichern = new JButton();
  private JLabel jLabel10 = new JLabel();
  private JTextArea jTextArea_showHA = new JTextArea("");
    private JScrollPane jTextArea1ScrollPane = new JScrollPane(jTextArea_showHA);
  private JLabel jLabel11 = new JLabel();
  private JButton jButton1_filtern = new JButton();
  private JButton jButton1_alleAnzeigen = new JButton();
  private JButton jButton1_sortierenDatum = new JButton();
  private JButton jButton1_sortByPriority = new JButton();
  private JLabel jLabel12 = new JLabel();
  private JNumberField jNumberField1_anzahl = new JNumberField();
  // Ende Attribute
  
  public GUI_HAEingabe(String title) { 
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 855; 
    int frameHeight = 474;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    jLabel1.setBounds(224, 8, 331, 49);
    jLabel1.setText("Hausaufgaben-Manager");
    jLabel1.setFont(new Font("Dialog", Font.BOLD, 28));
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    cp.add(jLabel1);
    jLabel2.setBounds(16, 104, 51, 25);
    jLabel2.setText("Fach:");
    cp.add(jLabel2);
    
    jComboBox1_fach.setBounds(80, 104, 177, 25);
    jComboBox1_fach.setModel(new DefaultComboBoxModel<String>(new String[] {"Mathematik", "Deutsch", "Franzoesich", "Englisch", "Physik", "Chemie", "Biologie", "Religion"}));
    jComboBox1_fach.setSelectedIndex(0);
    cp.add(jComboBox1_fach);
    
    jLabel3.setBounds(88, 64, 110, 25);
    jLabel3.setText("Eingabe");
    jLabel3.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(jLabel3);
    jLabel4.setBounds(16, 152, 126, 25);
    jLabel4.setText("Abgabedatum");
    jLabel4.setFont(new Font("Dialog", Font.PLAIN, 18));
    cp.add(jLabel4);
    jSpinner1_day.setBounds(56, 184, 50, 25);
    jSpinner1_day.setValue(1);
    jSpinner1_day.setModel(jSpinner1_day_dayModel);
    cp.add(jSpinner1_day);
    jLabel5.setBounds(16, 184, 35, 25);
    jLabel5.setText("Tag:");
    cp.add(jLabel5);
    jLabel6.setBounds(120, 184, 43, 25);
    jLabel6.setText("Monat:");
    cp.add(jLabel6);
    jSpinner1_month.setBounds(160, 184, 50, 25);
    jSpinner1_month.setValue(12);
    jSpinner1_month.setModel(jSpinner1_monthModel);
    cp.add(jSpinner1_month);
   
    jLabel7.setBounds(224, 184, 43, 25);
    jLabel7.setText("Jahr:");
    cp.add(jLabel7);
    jSpinner1_year.setBounds(264, 184, 70, 25);
    jSpinner1_year.setValue(2016);
    jSpinner1_year.setModel(jSpinner1_yearModel);
    
    JSpinner.NumberEditor editor = new JSpinner.NumberEditor(jSpinner1_year);
    editor.getFormat().setGroupingUsed(false);
    jSpinner1_year.setEditor(editor);
    
    cp.add(jSpinner1_year);
   
    jLabel8.setBounds(16, 232, 51, 25);
    jLabel8.setText("Prioritat");
    cp.add(jLabel8);
    
    jComboBox1_prioritaet.setBounds(80, 232, 60, 25);
    jComboBox1_prioritaet.setModel(new DefaultComboBoxModel<String>(new String[] {"1", "2", "3", "4"}));
    jComboBox1_prioritaet.setSelectedIndex(0);
    cp.add(jComboBox1_prioritaet);
    
    jLabel9.setBounds(16, 280, 59, 25);
    jLabel9.setText("Inhalt");
    cp.add(jLabel9);
    jTextArea1_inhalt_inhaltScrollPane.setBounds(16, 304, 305, 73);
    cp.add(jTextArea1_inhalt_inhaltScrollPane);
    //von hand
     jTextArea1_inhalt.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        if (e.getButton() == MouseEvent.BUTTON1) {
          jTextArea1_inhalt.setText("");
        }
      }
    });
    
    jButton1_speichern.setBounds(208, 392, 113, 25);
    jButton1_speichern.setText("Speichern");
    jButton1_speichern.setMargin(new Insets(2, 2, 2, 2));
    jButton1_speichern.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_speichern_ActionPerformed(evt);
      }
    });
    cp.add(jButton1_speichern);
    jLabel10.setBounds(560, 64, 110, 25);
    jLabel10.setText("Anzeige");
    jLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
    cp.add(jLabel10);
    jTextArea1ScrollPane.setBounds(368, 144, 449, 233);
    cp.add(jTextArea1ScrollPane);
    jLabel11.setBounds(370, 104, 150, 25);
    jLabel11.setText("Nach Datum filtern");
    cp.add(jLabel11);
    jComboBox1_choosedDate.setBounds(488, 104, 105, 25);
    cp.add(jComboBox1_choosedDate);
    jButton1_filtern.setBounds(600, 104, 105, 25);
    jButton1_filtern.setText("Filtern");
    jButton1_filtern.setMargin(new Insets(2, 2, 2, 2));
    jButton1_filtern.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_filtern_ActionPerformed(evt);
      }
    });
    cp.add(jButton1_filtern);
    jButton1_alleAnzeigen.setBounds(696, 392, 121, 25);
    jButton1_alleAnzeigen.setText("Alle Anzeigen");
    jButton1_alleAnzeigen.setMargin(new Insets(2, 2, 2, 2));
    jButton1_alleAnzeigen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_alleAnzeigen_ActionPerformed(evt);
      }
    });
    cp.add(jButton1_alleAnzeigen);
    jButton1_sortierenDatum.setBounds(370, 392, 140, 25);
    jButton1_sortierenDatum.setText("Sortieren Datum");
    jButton1_sortierenDatum.setMargin(new Insets(2, 2, 2, 2));
    jButton1_sortierenDatum.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_sortierenDatum_ActionPerformed(evt);
      }
    });
    cp.add(jButton1_sortierenDatum);
    jButton1_sortByPriority.setBounds(520, 392, 150, 25);
    jButton1_sortByPriority.setText("Sortieren Prioritaet");
    jButton1_sortByPriority.setMargin(new Insets(2, 2, 2, 2));
    jButton1_sortByPriority.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jButton1_sortByPriority_ActionPerformed(evt);
      }
    });
    cp.add(jButton1_sortByPriority);
    jLabel12.setBounds(730, 104, 54, 20);
    jLabel12.setText("Anzahl:");
    cp.add(jLabel12);
    jNumberField1_anzahl.setBounds(784, 104, 33, 25);
    jNumberField1_anzahl.setText("");
    cp.add(jNumberField1_anzahl);
    // Ende Komponenten
    
    //init of the program
    myHA_list = new HA_Liste();
    setStartValues();
    
    
    setVisible(true);
  } // end of public GUI_HAEingabe
  
  // Anfang Methoden
  public void jButton1_speichern_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einf?gen
    String fach = (String)jComboBox1_fach.getSelectedItem();
    String datum = ""+(jSpinner1_year.getValue());
    int curMonth = (Integer)jSpinner1_month.getValue();
    int curDay = (Integer)jSpinner1_day.getValue();
    if (curMonth<10) {
        datum += "0"+jSpinner1_month.getValue();
    } else {
        datum += ""+jSpinner1_month.getValue();
    }
    if (curDay<10) {
        datum += "0"+jSpinner1_day.getValue();
    } else {
        datum += ""+jSpinner1_day.getValue();
    }
    int priority = Integer.parseInt((String)(jComboBox1_prioritaet.getSelectedItem()));
    String inhalt = jTextArea1_inhalt.getText();
    myHA_list.hinzufuegen(new Hausaufgabe(fach,datum,inhalt,priority,false));
    showAllHA();
    setStartValues();
    //myHA_list.hinzufuegen(new )
  } // end of jButton1_sortByPriority_sortierenDatum_alleAnzeigen_filtern_speichern_ActionPerformed

  public void jButton1_filtern_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einf?gen
    String choosedDate = (String)jComboBox1_choosedDate.getSelectedItem();
    String[] arrayOfAllHA = myHA_list.getAllInfosForGUI().split("#");
    String allHAofOneDate = "";
    for (int i = 0; i<arrayOfAllHA.length; i++) {
          String curDate = arrayOfAllHA[i].split(";")[0];
          if (choosedDate.equals(curDate)) {
              allHAofOneDate += "#"+arrayOfAllHA[i];
          }
    }
    allHAofOneDate = allHAofOneDate.substring(1, allHAofOneDate.length());
    jNumberField1_anzahl.setInt(allHAofOneDate.split("#").length);
    jTextArea_showHA.setText(allHAofOneDate.replaceAll("#", "\n").replaceAll(";", "\t") );
  } // end of jButton1_sortByPriority_sortierenDatum_alleAnzeigen_filtern_ActionPerformed

  public void jButton1_alleAnzeigen_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einf?gen
    showAllHA();
  } // end of jButton1_sortByPriority_sortierenDatum_alleAnzeigen_ActionPerformed

  public void jButton1_sortierenDatum_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einf?gen
  } // end of jButton1_sortByPriority_sortierenDatum_ActionPerformed

  public void jButton1_sortByPriority_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einf?gen
  } // end of jButton1_sortByPriority_ActionPerformed

  private void setStartValues() {
      int year = Calendar.getInstance().get(Calendar.YEAR);
      int month = Calendar.getInstance().get(Calendar.MONTH)+1;
      int day = Calendar.getInstance().get(Calendar.DAY_OF_MONTH);
      jSpinner1_year.setValue(year);
      jSpinner1_month.setValue(month);
      jSpinner1_day.setValue(day);
      jComboBox1_prioritaet.setSelectedIndex(1);
      setDummytext();
  }
  
  private void clearAnzeige() {
      jTextArea1_inhalt.setText("");
  }
  
  private void setDummytext() {
      String myText = "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.";
      Random wuerfel = new Random();
      int newLength = wuerfel.nextInt(myText.length()-10)+10;
      jTextArea1_inhalt.setText(myText.substring(newLength-10, newLength));
    }
  
  private void showAllHA() {
      clearAnzeige();
      String allInfos = myHA_list.getAllInfosForGUI();
      jTextArea_showHA.setText(allInfos.replaceAll("#", "\n").replaceAll(";", "\t") );
      jNumberField1_anzahl.setInt(myHA_list.getNumberOf());
      
      
      String[] arrayOfAllHA = allInfos.split("#");
      String listOfAllDates = "";
      for (int i = 0; i<arrayOfAllHA.length; i++) {
          String curDate = arrayOfAllHA[i].split(";")[0];
          if (listOfAllDates.indexOf(curDate)==-1) { //nicht vorhanden
              listOfAllDates += "#"+curDate;
          }
      }
      //Ersten Hash entfernen
      listOfAllDates = listOfAllDates.substring(1, listOfAllDates.length());
      String[] actListOfDates = listOfAllDates.split("#");
      jComboBox1_choosedDate.setModel(new DefaultComboBoxModel<String>(bubbleSortStringArray(actListOfDates)));
    }
    
    private String[] bubbleSortStringArray(String[] array2Sort) {
        for (int i = 0; i<array2Sort.length-1; i++) {
            for (int j = i+1; j<array2Sort.length; j++) {
                if (array2Sort[i].compareTo(array2Sort[j]) > 0) {
                    String tmp = array2Sort[i];
                    array2Sort[i] = array2Sort[j];
                    array2Sort[j] = tmp;
                }
            }
        }
        return array2Sort;
    }
    
  // Ende Methoden
  
  public static void main(String[] args) {
    new GUI_HAEingabe("GUI_HAEingabe");
  } // end of main
  
} // end of class GUI_HAEingabe
